<?
/* 
-------------------------------------------------------------------------
./logicaland 0.1 - a participative global simulation
-------------------------------------------------------------------------
Copyright (c) 2002 ./logicaland (http://www.logicaland.net)
Michael Aschauer, Josef Deinhofer (io@logicland.net)
-------------------------------------------------------------------------
For information on usage and redistribution, and for a DISCLAIMER OF ALL
WARRANTIES, see the file, "LICENSE.txt," in this distribution.  
-------------------------------------------------------------------------
*/

require("inc/phplib/template.inc");
require("conf/mysql_conf.php");
require("inc/MySQLSession.class.php");


$sess= new MySQLSession($mysql_conf);


$logged_in = false;

if ($action == "login") 
{ 
	if(!doLogin()) doLoginForm("login failed.");
	if (!$sess->isAdmin()) 
	{
		$sess->logout($sess->getSessionID());
		showErrorPage("your are not allowed to enter admin!");
	}
	else unset($action);
}
else if (empty($sid)) doLoginForm("");
else if (!$sess->isValid($sid)) doLoginForm("session invalid");
else if ($action == "logout") doLogout();


$user_data = $sess->getUserData();

$USER_TYPES = array("anonym","user","admin"); 




if($action == "delete_user")
{
	$result = $sess->query("delete from users where id=$id");
	$action = "show_user";
}
else if($action == "update_user")
{
	$result = $sess->query("UPDATE users SET name='$name', email='$email', type=$user_type WHERE id=$id");
	$action = "show_user";
}
else if($action == "change_pwd")
{
	$result = $sess->query("UPDATE users SET pwd=md5('$pwd') WHERE id=$id");
	$action = "show_user";
}
else if($action == "add_user")
{
	$result = $sess->query("INSERT into users SET name='$name', email='$email', pwd=md5('$pwd'), type=$user_type");
	$action = "show_user";
}
else if($action == "empty_game_log")
{
	$result = $sess->query("DELETE FROM game_log");
	$action = "show_game_log";
}
else if($action == "empty_error_log")
{
	$result = $sess->clear_error_logs();
	$action = "show_error_log";
}
else if($action == "empty_ui_log")
{
	$result = $sess->query("DELETE FROM ui_data");
	$action = "show_ui_log";
}
else if($action=="apply_changes")
{
	if (empty($anonym)) $anonym=0;
	$query="	UPDATE game_flags 
			SET 
				status='$status',
				interval_time= $interval,
				preroll= $preroll, 
				foresight= $forsight, 
				actYear= $act_year,					
				allow_nobody= $anonym,
				refresh_time= $refresh_time
			WHERE 1=1"; 		
	$sess->query($query);
	$msg = "change done.";
	$action = "options";
}
else if($action=="reset_game")
{
	$query="	UPDATE game_flags 
			SET 
				status='running',
				start_time=NOW(),
				actYear=preroll
			WHERE 1=1"; 					
	$sess->query($query);

	// Maybe save somewhere before deleting
	$sess->query("DELETE FROM ui_data");	
	//$sess->query("DELETE FROM game_log");		
	
	$msg = "games restartet !!!";
	$action = "options";	
}		



// ------------------------
// HOME
// ------------------------------

if (empty($action))
{
	$tpl = new Template();
	$tpl->set_file(array(
		"seite" => "tpl/admin.html",
		"header" => "tpl/admin_header.html",
		"content" => "tpl/admin_entry.html",
		"navigation" => "tpl/admin_navigation.html" ));
	
	
	$tpl->set_block("seite","header","head");	
	
	$tpl->set_var(array(
		"USER_NAME" => $user_data["name"],
		"USER_ONLINE" => $sess->getUserOnline(),
		"LINK_LOGOUT" => $PHP_SELF.$sess->getSessionString()."&action=logout"
		));
	$tpl->parse("head", "header");	

	$row = $sess->singleSelect("SELECT * FROM game_flags");
	
	if ($row["status"]=="running")
	{
		$year_row = $sess->singleSelect("SELECT 
						( TIME_TO_SEC(NOW()) - TIME_TO_SEC(start_time) 
						   + (TO_DAYS(now()) - TO_DAYS(start_time))*1440*60
						) /(interval_time*60) 
						+ preroll 
					as currentYear,
						(interval_time*60) - ( TIME_TO_SEC(NOW()) - TIME_TO_SEC(start_time) + (TO_DAYS(now()) - TO_DAYS(start_time))*1440*60
						) % (interval_time*60) 
					as next_time
					FROM game_flags");
	}
	else
	{
		$year_row = $sess->singleSelect("SELECT actYear as currentYear FROM game_flags");
		$year_row["next_time"] = "??";
	}

	$currentYear = floor($year_row["currentYear"]);	
	$next_time = $year_row["next_time"];
	
	$tpl->set_block("seite","content","cont");	
	$tpl->set_var(array(
			"STATUS" => $row["status"],
			"CURRENT_YEAR" => $currentYear,
			"START_TIME" => $row["start_time"],
			"NEXT_TIME" => $next_time
		));
	$tpl->parse("cont", "content", true);


	$tpl->set_block("seite","navigation","nav");	
	$tpl->set_var(array(
		"SESSION_STRING"=> $sess->getSessionString()
		));
	$tpl->parse("nav", "navigation", true);
	
	$tpl->parse("out", "seite");
	$tpl->p("out");

}

// -------------------
// SHOW USER
// --------------------

else if ($action == "show_user")
{
	if (empty($order)) $order="name";
	if ($order=="lastLogin" || $order=="lastAction" || $order=="type") $order .= " desc";

	$result = $sess->query("SELECT  id, name, email, lastLogin, lastAction, type 
				FROM users 
				ORDER BY $order");

	$user_count = mysql_num_rows($result);

	$tpl = new Template();
	$tpl->set_file(array(
		"seite" => "tpl/admin.html",
		"header" => "tpl/admin_header.html",
		"content" => "tpl/admin_user.html",
		"navigation" => "tpl/admin_navigation.html" ));
	
	$tpl->set_block("seite","header","head");		
	$tpl->set_var(array(
		"USER_NAME" => $user_data["name"],
		"USER_ONLINE" => $sess->getUserOnline(),
		"LINK_LOGOUT" => $PHP_SELF.$sess->getSessionString()."&action=logout"
		));
	$tpl->parse("head", "header");	

	$tpl->set_block("content","user","cont");
		
	
	
	while($row = mysql_fetch_array($result))
	{	
		$tpl->set_var(array(
			"USER"=> $row["name"],
			"EMAIL"=> $row["email"],
			"LAST_LOG"=> $row["lastLogin"],
			"LAST_ACT"=> $row["lastAction"],			
			"TYPE"=> $USER_TYPES[$row["type"]],
			"USER_ID"=> $row["id"],
			"LOGIN_NUM" => mysql_num_rows($sess->query("select user_id from game_log where user_id=".$row["id"]." and action='LOGIN'"))
				
		));
		$tpl->parse("cont", "user", true);
	}




	$tpl->set_block("seite","navigation","nav");	
	$tpl->set_var(array(
		"SESSION_STRING"=> $sess->getSessionString(),
		"USER_NUM"=> $user_count			
		));
	$tpl->parse("nav", "navigation", true);
	
	$tpl->parse("out", "seite");
	$tpl->p("out");
}

//-------------------
// EDIT USER
// --------------------

else if ($action == "user_edit")
{
	$user_types = array ("anonym","user","admin");
	
	$tpl = new Template();
	$tpl->set_file(array(
		"seite" => "tpl/admin.html",
		"header" => "tpl/admin_header.html",
		"content" => "tpl/admin_user_edit.html",
		"navigation" => "tpl/admin_navigation.html" ));
	
	$tpl->set_block("seite","header","head");		
	$tpl->set_var(array(
		"USER_NAME" => $user_data["name"],
		"USER_ONLINE" => $sess->getUserOnline(),
		"LINK_LOGOUT" => $PHP_SELF.$sess->getSessionString()."&action=logout"
		));
	$tpl->parse("head", "header");	

	$tpl->set_block("seite","content","cont");
		
	$row = $sess->singleSelect("SELECT id, name, email, type FROM users WHERE id=$id");
	
	
	$tpl->set_var(array(
		"ID"=> $id,	
		"NAME"=> $row["name"],
		"EMAIL"=> $row["email"],			
		"ACTION"=> "update_user",
		"USER_VAL" => $row["type"],
		"USER_TYPE" => $user_types[$row["type"]],	
		"MSG" => $msg
		));

	$tpl->parse("cont", "content", true);


	$tpl->set_block("seite","navigation","nav");	
	$tpl->set_var(array(
		"SESSION_STRING"=> $sess->getSessionString()
		));
	$tpl->parse("nav", "navigation", true);
	
	$tpl->parse("out", "seite");
	$tpl->p("out");
}

//-------------------
// NEW USER
// ---------------------
else if ($action == "new_user")
{
	$user_types = array ("anonym","user","admin");
	
	$tpl = new Template();
	$tpl->set_file(array(
		"seite" => "tpl/admin.html",
		"header" => "tpl/admin_header.html",
		"content" => "tpl/admin_user_new.html",
		"navigation" => "tpl/admin_navigation.html" ));
	
	$tpl->set_block("seite","header","head");		
	$tpl->set_var(array(
		"USER_NAME" => $user_data["name"],
		"USER_ONLINE" => $sess->getUserOnline(),
		"LINK_LOGOUT" => $PHP_SELF.$sess->getSessionString()."&action=logout"
		));
	$tpl->parse("head", "header");	

	$tpl->set_block("seite","content","cont");			
	
	$tpl->set_var(array(	
		"MSG" => $msg
		));

	$tpl->parse("cont", "content", true);


	$tpl->set_block("seite","navigation","nav");	
	$tpl->set_var(array(
		"SESSION_STRING"=> $sess->getSessionString()
		));
	$tpl->parse("nav", "navigation", true);
	
	$tpl->parse("out", "seite");
	$tpl->p("out");
}

//_-----------------------
// SHOW ONLINE users
//-----------------------------

else if ($action == "show_online")
{
	if (empty($order)) $order="name";
	if ($order=="lastLogin" || $order=="lastLogin" || $order=="type") $order .= " desc";

	$tpl = new Template();
	$tpl->set_file(array(
		"seite" => "tpl/admin.html",
		"header" => "tpl/admin_header.html",
		"content" => "tpl/admin_online.html",
		"navigation" => "tpl/admin_navigation.html" ));
	
	$tpl->set_block("seite","header","head");		
	$tpl->set_var(array(
		"USER_NAME" => $user_data["name"],
		"USER_ONLINE" => $sess->getUserOnline(),
		"LINK_LOGOUT" => $PHP_SELF.$sess->getSessionString()."&action=logout"
		));
	$tpl->parse("head", "header");	

	$tpl->set_block("content","user","cont");
		
	$result = $sess->query("SELECT  u.name, u.email, u.lastLogin, u.type, s.ip 
				FROM users u, sessions s
				WHERE u.id=s.user_id
		 		ORDER BY $order");
	while($row = mysql_fetch_array($result))
	{	
		$tpl->set_var(array(
			"USER"=> $row["name"],
			"EMAIL"=> $row["email"],
			"LAST_LOG"=> $row["lastLogin"],
			"IP"=> $row["ip"],	
			"HOST"=> gethostbyaddr($row["ip"]),
			"TYPE" => $USER_TYPES[$row["type"]]				
		));
		$tpl->parse("cont", "user", true);
	}




	$tpl->set_block("seite","navigation","nav");	
	$tpl->set_var(array(
		"SESSION_STRING"=> $sess->getSessionString()
		));
	$tpl->parse("nav", "navigation", true);
	
	$tpl->parse("out", "seite");
	$tpl->p("out");
}

//--------------------------
// GAME OPTIONS
//------------------------------

else if ($action == "options")
{	
	$tpl = new Template();
	$tpl->set_file(array(
		"seite" => "tpl/admin.html",
		"header" => "tpl/admin_header.html",
		"content" => "tpl/admin_options.html",
		"navigation" => "tpl/admin_navigation.html" ));
	
	$tpl->set_block("seite","header","head");		
	$tpl->set_var(array(
		"USER_NAME" => $user_data["name"],
		"USER_ONLINE" => $sess->getUserOnline(),
		"LINK_LOGOUT" => $PHP_SELF.$sess->getSessionString()."&action=logout"
		));
	$tpl->parse("head", "header");	

	$tpl->set_block("seite","content","cont");
		
	$row = $sess->singleSelect("SELECT * FROM game_flags");
	
	if($row["allow_nobody"]==1) $anonym = "checked"; else $anonym="";
	
	$tpl->set_var(array(
		"STATUS"=> $row["status"],
		"PREROLL"=> $row["preroll"],
		"FORSIGHT"=> $row["foresight"],			
		"INTERVAL"=> $row["interval_time"],
		"ANONYM" => $anonym,
		"MSG" => $msg,
		"ACT_YEAR" => $row["actYear"],
		"REFRESH_TIME" => $row["refresh_time"]
		));

	$tpl->parse("cont", "content", true);




	$tpl->set_block("seite","navigation","nav");	
	$tpl->set_var(array(
		"SESSION_STRING"=> $sess->getSessionString()
		));
	$tpl->parse("nav", "navigation", true);
	
	$tpl->parse("out", "seite");
	$tpl->p("out");
}

// ----------------
// GAME LOGS
// --------------------

else if ($action == "show_game_log")
{
	if (empty($order)) $order="time";
	if ($order=="time") $order .= " desc";

	$tpl = new Template();
	$tpl->set_file(array(
		"seite" => "tpl/admin.html",
		"header" => "tpl/admin_header.html",
		"content" => "tpl/admin_game_log.html",
		"navigation" => "tpl/admin_navigation.html" ));
	
	$tpl->set_block("seite","header","head");		
	$tpl->set_var(array(
		"USER_NAME" => $user_ip["name"],
		"USER_ONLINE" => $sess->getUserOnline(),
		"LINK_LOGOUT" => $PHP_SELF.$sess->getSessionString()."&action=logout"
		));
	$tpl->parse("head", "header");	

	$tpl->set_block("content","log","cont");
		
	$result = $sess->query("SELECT  
					u.name, 
					g.ip, 
					g.action, 
					DATE_FORMAT(g.time,'%Y-%m-%d %H:%i') as time, 
					g.country
				FROM users u, game_log g
				WHERE u.id = g.user_id
		 		ORDER BY $order limit 100");
				
	while($row = mysql_fetch_array($result))
	{	
		$tpl->set_var(array(
			"USER"=> $row["name"],
			"ACTION"=> $row["action"],
			"IP"=> $row["ip"],	
			"COUNTRY"=> $row["country"],	
			"HOST"=> @gethostbyaddr($row["ip"]),
			"TIME"=> $row["time"],			
		));
		$tpl->parse("cont", "log", true);
	}




	$tpl->set_block("seite","navigation","nav");	
	$tpl->set_var(array(
		"SESSION_STRING"=> $sess->getSessionString()
		));
	$tpl->parse("nav", "navigation", true);
	
	$tpl->parse("out", "seite");
	$tpl->p("out");
}

//-------------------------
// UI DATA
//------------------------------


else if ($action == "show_ui_log")
{
	if (empty($order)) $order="time";
	if ($order=="time") $order .= " desc";

	$tpl = new Template();
	$tpl->set_file(array(
		"seite" => "tpl/admin.html",
		"header" => "tpl/admin_header.html",
		"content" => "tpl/admin_ui_log.html",
		"navigation" => "tpl/admin_navigation.html" ));
	
	$tpl->set_block("seite","header","head");		
	$tpl->set_var(array(
		"USER_NAME" => $user_ip["name"],
		"USER_ONLINE" => $sess->getUserOnline(),
		"LINK_LOGOUT" => $PHP_SELF.$sess->getSessionString()."&action=logout"
		));
	$tpl->parse("head", "header");	

	$tpl->set_block("content","log","cont");
		
	$result = $sess->query("SELECT  u.name, 
					g.ip, g.year, g.region, 
					g.food_aid, g.util_aid,
					g.dist_indust, g.dist_agri,
					g.dist_tech, g.dist_other,
					DATE_FORMAT(g.time,'%Y-%m-%d %H:%i') as time
				FROM users u, ui_data g
				WHERE u.id = g.user_id
		 		ORDER BY $order limit 100");
				
	while($row = mysql_fetch_array($result))
	{	
		$tpl->set_var(array(
			"USER"=> $row["name"],
			"ACTION"=> $row["action"],
			"IP"=> $row["ip"],	
			"YEAR"=> $row["year"],			
			"REGION"=> $row["region"],			
			"FOOD_AID"=> $row["food_aid"],
			"UTIL_AID"=> $row["util_aid"],
			"DIST_INDUST"=> $row["dist_indust"],
			"DIST_AGRI"=> $row["dist_agri"],
			"DIST_TECH"=> $row["dist_tech"],
			"DIST_OTHER"=> $row["dist_other"],
			"TIME"=> $row["time"],			
		));
		$tpl->parse("cont", "log", true);
	}




	$tpl->set_block("seite","navigation","nav");	
	$tpl->set_var(array(
		"SESSION_STRING"=> $sess->getSessionString()	
		));
	$tpl->parse("nav", "navigation", true);
	
	$tpl->parse("out", "seite");
	$tpl->p("out");
}

//-------------------------
// SHOW ERROR LOG
//------------------------------


else if ($action == "show_error_log")
{

	$tpl = new Template();
	$tpl->set_file(array(
		"seite" => "tpl/admin.html",
		"header" => "tpl/admin_header.html",
		"content" => "tpl/admin_error_log.html",
		"navigation" => "tpl/admin_navigation.html" ));
	
	$tpl->set_block("seite","header","head");		
	$tpl->set_var(array(
		"USER_NAME" => $user_ip["name"],
		"USER_ONLINE" => $sess->getUserOnline(),
		"LINK_LOGOUT" => $PHP_SELF.$sess->getSessionString()."&action=logout"
		));
	$tpl->parse("head", "header");	
	

	if ($fd = @fopen("log/error.log", "r"))
	{
		while (!feof ($fd)) $logs .= fgets($fd, 4096);
		fclose ($fd);
	}
	else
	{
		$logs = "file not found";
	}	
		
	$tpl->set_block("seite","content","cont");		
	$tpl->set_var(array(
		"LOGS" => $logs,	
		));
	$tpl->parse("cont", "content", true);
	
	$tpl->set_block("seite","navigation","nav");	
	$tpl->set_var(array(
		"SESSION_STRING"=> $sess->getSessionString()	
		));
	$tpl->parse("nav", "navigation", true);	
	
	$tpl->parse("out", "seite");
	$tpl->p("out");	

			
}





	
?>
