
# Table structure for table `msg_general`
#

CREATE TABLE msg_general (
  id 		int(11) NOT NULL auto_increment,
  parent_id 	int(11) default '0',
  root_id 	int(11) default '0',
  subject 	varchar(255) default NULL,
  text 		text,
  create_dt 	datetime default NULL,
  modify_dt 	timestamp(14) NOT NULL,
  author 	varchar(255) default NULL,

  KEY msg_general_key (id)
);


#
# Table structure for table `sessions`
#

CREATE TABLE sessions (
  id 		varchar(50) NOT NULL default '',
  user_id 	int(8) NOT NULL default '0',
  ip		mediumtext NOT NULL,
  t_stamp 	timestamp(14) NOT NULL,
  PRIMARY KEY  (id),

  KEY t_stamp (t_stamp)
);



# Table structure for table `users`
#

CREATE TABLE users (
  id 		int(8) NOT NULL auto_increment,
  type 		int(4) NOT NULL default '0',
  name 		varchar(50) NOT NULL default '',
  pwd 		varchar(50) NOT NULL default '',
  email 	varchar(100) default NULL,
  lastLogin 	datetime default NULL,
  lastAction 	datetime default NULL,
  PRIMARY KEY  (id),

  KEY 		name (name)
);

INSERT INTO users VALUES (1, 2, 'admin', md5('test'), NULL, NULL, NULL);



CREATE TABLE ui_data
(
  user_id int(8) NOT NULL,
  ip varchar(15),

  year int(4) NOT NULL,
  region int(4) NOT NULL,

  food_aid double NOT NULL,
  util_aid double NOT NULL,

  dist_indust double NOT NULL,
  dist_agri double NOT NULL,
  dist_tech double NOT NULL,
  dist_other double NOT NULL,	

  time timestamp NOT NULL
	
);



CREATE TABLE game_flags 
(
  status varchar(15) NOT NULL,
  start_time datetime NOT NULL,  
  actYear int(4) NOT NULL,
  interval_time int(8) NOT NULL,
  preroll int(4) NOT NULL,
  foresight int(4) NOT NULL,  
  allow_nobody int(1) NOT NULL,
  refresh_time int(8) NOT NULL 
);

INSERT INTO game_flags VALUES ('offline', now(), 10, 120, 15, 15, 0, 5);

    



CREATE TABLE game_log 
(
  user_id int(8) NOT NULL,
  ip varchar(15) NOT NULL,
  country varchar(8) NOT NULL,
  action varchar(15) NOT NULL,
  time timestamp NOT NULL,
  
  PRIMARY KEY (time)
);
 
 
 
CREATE TABLE world_data
(
  name mediumtext NOT NULL,
  code varchar(8) default '' NOT NULL,
  yPos double default '0' NOT NULL,  
  xPos double default '0' NOT NULL,
  area double default '0' NOT NULL,
  population double default '0' NOT NULL,
  gdp_per_cap double default '0' NOT NULL,
  inet_user double default '0' NOT NULL,
  inet_provider double default '0' NOT NULL,
  
  PRIMARY KEY (code)
  
);




