<?
header("Content-Type: text/plain");
require("../conf/mysql_conf.php");
require("../inc/MySQLSession.class.php");

$sess= new MySQLSession($mysql_conf,true);
if (!$sess->isConnected())
{
	echo "success=false\n";
	echo "error=database error\n";
	exit;
}


// Check if Session is Valid 
// ---------------------------

if (!$sess->isValid($sid))
{
	$sess->error_log("logica_SUBMIT: submit for invalid year from ". $user_data["name"] . " [" . $user_data["ip"] . "]");
	echo "success=false\n";
	echo "error=session invalid\n";
	exit;
}
$user_data = $sess->getUserData(); 
$user_id = $user_data["id"];



// Check if Year is Valid
// -----------------------

$row = $sess->singleSelect("SELECT * FROM game_flags");

if ($row["status"]=="running")
{
	$year_row = $sess->singleSelect("SELECT 
						( TIME_TO_SEC(NOW()) - TIME_TO_SEC(start_time) 
						   + (TO_DAYS(now()) - TO_DAYS(start_time))*1440*60
						) /(interval_time*60) 
						+ preroll 
					as currentYear 
					FROM game_flags");
}
else
{
	$year_row = $sess->singleSelect("SELECT actYear as currentYear FROM game_flags");
}

$currentYear = floor($year_row["currentYear"]);


if ($currentYear!=$actYear)
{
	echo "success=false\n";
	echo "error=invalid year!\n";
	$sess->error_log("logica_SUBMIT: submit for invalid year from ". $user_data["name"] . " [" . $user_data["ip"] . "]");
	exit;
}


// Check if User has already submitted this year
// ----------------------------------------------

if ($row["status"]=="running" && $user_data["name"]!="bigguest" && !($user_data["name"]=="nobody" && $allow_nobody))
{								
	$year_row = $sess->singleSelect("SELECT 
						( TIME_TO_SEC(u.lastAction) - TIME_TO_SEC(g.start_time) 
					   	  + ( TO_DAYS(u.lastAction) - TO_DAYS(g.start_time)) *1440*60 
						) / (g.interval_time *60) 
						+  g.preroll
					AS lastSubmitYear, u.lastAction
					FROM users u, game_flags g WHERE id=$user_id");
				
	$lastSubmitYear = $year_row["lastSubmitYear"];	
	
	if ($lastSubmitYear>=$currentYear)
	{
		echo "success=false\n";
		echo "error=you already submitted this year!\n";
		exit;
	}
}


// INSERT UI_DATA if ui_data isset
// ----------------------------------

if (isset($ui_data))
{
	$line = explode("\n",$ui_data);

	for ($i=0; $i < sizeof($line);$i++)
	{
		$row = explode(";",$line[$i]);
		if ($row[0]!="")
		{				
			$query_string = "
					INSERT INTO ui_data
					SET
					 user_id = ". $user_data["id"] .",
					 year = $actYear,
					 region = $row[0],
					 util_aid = " . number_format($row[1],2) .", 
					 food_aid = " . number_format($row[2],2) .", 
					 dist_indust = " . number_format($row[3],2) .", 
					 dist_agri = " . number_format($row[4],2) .", 
					 dist_tech = " . number_format($row[5],2) .", 
					 dist_other = " . number_format($row[6],2) .", 
					 ip = '".$HTTP_SERVER_VARS["REMOTE_ADDR"]."',
					 time = null";
					 
			$sess->query($query_string);
			//echo $query_string."\n";		
		}
	}	

	$sess->log("SUBMIT");
	$result = $sess->query("UPDATE users SET lastAction=NOW() where id=".$user_data["id"]);

	if ($result)
	{
		echo "success=true\n";
		echo "error=submit done.";			 			
	}
	else
	{
		echo "succes=false\n";
		echo "database insert failed";
	}
}
else
{
	echo "success=false\n";
	echo "error=no ui_data sent..";
}
?>
