<?
/* 
-------------------------------------------------------------------------
./logicaland 0.1 - a participative global simulation
-------------------------------------------------------------------------
Copyright (c) 2002 ./logicaland (http://www.logicaland.net)
Michael Aschauer, Josef Deinhofer (io@logicland.net)
-------------------------------------------------------------------------
For information on usage and redistribution, and for a DISCLAIMER OF ALL
WARRANTIES, see the file, "LICENSE.txt," in this distribution.  
--------------------------------------------------------
 */
 
 
// ----------------------------------------
// MySQLSession class for logicaland
// -----------------------------------
//
// addON: global function:
// 	doLogout()
//	doLogin()
//	doLoginForm(msg)
//

class MySQLSession
{
	var $db_handle;
	var $max_lifetime;

	
	var $session_id;
	var $user_data;
	var $error_msg;
	
	var $quiet;
	var $connected;
	
	
       	function MySQLSession($mysql_conf, $quiet=false)	
       	{
		$this->quiet = $quiet;
		
       		$this->db_handle = mysql_connect($mysql_conf["host"], $mysql_conf["user"], $mysql_conf["pwd"]);
		
		if ($this->db_handle == 0) 
		{
			$this->error_log("[mysql_error] ". mysql_error());
			$this->connected = 0;						
			if($quiet) 
			{		
				exit;
			}
			else
				showErrorPage("sorry. database unreachable!");
		}

		@mysql_select_db($mysql_conf["dbname"],$this->db_handle);
		
		/*{
			if($quiet) 
				exit;
			else
				showErrorPage("sorry. database unreachable!");
		}*/
		
		/*if($quiet) 
		{
			$this->error_log(mysql_error());
			exit;
		}
		else
		{
			$this->error_log(mysql_error());
			showErrorPage("sorry. database unreachable!");
		}*/
		
		$this->connected = 1;
		$this->max_lifetime = 600;
		$this->error_msg = ""; 
	}


	function singleSelect($query)
	{
		$result = @mysql_query($query);
			
		if (@mysql_num_rows($result)!=0) 
			return @mysql_fetch_array($result);
    		else 
		{
			//$this->error_log(mysql_error());
			return 0;
		}
	}

	function query($query)
	{
		$result = @mysql_query($query);
				
		
		if (!$result)
		{ 
			$this->error_log("[mysql_error] " . mysql_error());
			if (!$this->quiet)
			{
				showErrorPage("sorry. error during database operation.");
			}
		}
		return $result;
	
	}
	
	
	// Checks if a valid session exists
	function isValid($sess_id = "")		
	{	
		$this->session_id = $sess_id;
		
		$too_old = time() - ($this->max_lifetime);
		
		$this->query("DELETE from sessions WHERE UNIX_TIMESTAMP(t_stamp) < $too_old");
			
		$row = $this->singleSelect("SELECT user_id, UNIX_TIMESTAMP(t_stamp) as t_stamp FROM sessions WHERE id = '".$this->session_id."'");

		if($row == 0) return false;
		else
		{
			// Get User Data
			$this->setUserData($row["user_id"]);
			$this->query("UPDATE sessions SET t_stamp=null WHERE id = '$sess_id'");			
			return true;
		}
	}
	
	

	function auth( $name = "anonym" , $pwd = "x" , $ip = "")
	{
						
		$row = $this->singleSelect("Select id, pwd from users where name=\"$name\"");
		if ($row!=0)
		{
			if ( $row["pwd"] == md5($pwd) || ($allow_nobody && $name=="nobody"))
			{	
				srand((double)microtime()*1000000);
				$sess_id = md5(uniqid(rand()));
				
				$this->session_id = $sess_id;										
				$this->query("INSERT into sessions VALUES ('$sess_id',".$row["id"].",'$ip', null)");				
				$this->setUserData($row["id"]);
				$this->query("UPDATE users SET lastLogin=NOW() WHERE id = ".$row["id"]);	
				$this->log("LOGIN");							
				return true;
			}
			else
			{
				$this->error_log("[fail login] [".$ip."]" . " for user: ". $name . "\n");
				$this->error_msg = "login failed.";
				return false;
			}
		}
		else
		{
			$this->error_log("[fail login] [".$ip."]" . " for user: ". $name . "\n");
			$this->error_msg = "login failed.";
		}
	}	
	
	function logout($sess_id)
	{
		$row = $this->singleSelect("SELECT user_id,ip FROM sessions WHERE id=\"$sess_id\"");
		$this->query("DELETE FROM sessions where id = \"$sess_id\"");
		$this->log("LOGOUT");		
		return true;
	}
	
	function userExists($name)
	{
		$row = $this->singleSelect("SELECT id from users where name='$name'");
		return ($row==0);
	}
	
	function register($name,$pwd="",$email="",$typ=1)
	{

		$this->query("INSERT into users set name='$name', pwd=MD5('$pwd'), email='$email', type=$typ");
		return true;
	}							
	
	function getSessionString()	
	{
		return "?sid=".$this->session_id;
		$this->error_msg = "logged out.";
	}
	
	function setUserData($id)
	{
			$user = $this->singleSelect("SELECT name, type, DATE_FORMAT(lastLogin,'%Y-%m-%d %H:%i') as lastLogin FROM users WHERE id = $id");			
			
			$this->user_data = array();
			$this->user_data["name"] = $user["name"];
			$this->user_data["type"] = $user["type"];
			$this->user_data["lastLogin"] = $user["lastLogin"];	
			$this->user_data["id"] = $id;

						
			$row = $this->singleSelect("SELECT ip from sessions where user_id=$id");

			$this->user_data["ip"] = $row["ip"];			
	}	

	function getSessionID()	
	{
		return $this->session_id;
	}

	function isAdmin()	
	{
		if ($this->user_data["type"] == 2)
			return true;
		else
			return false;
	}


	function getUserData()
	{
		return $this->user_data;
	}	
	
	function getUserOnline()
	{
		
		$row = $this->singleSelect("SELECT count(id) as nr from sessions");
		return $row["nr"];
	}	
	
	function getErrorMsg()
	{
		return $this->error_msg;
	}
	
	function isConnected()
	{
		return $this->connected;
	}				
	
	function log($action_string)
	{
		$ccode = strrchr(gethostbyaddr($this->user_data["ip"]),".");
		if (strpos("0123456789",$ccode{1}) || $ccode{0}=="") $ccode=".?";
		
		$this->query("INSERT into game_log 
				SET
					user_id=".$this->user_data["id"].",
					ip='".$this->user_data["ip"]."', 
					country = '$ccode',
					action='$action_string', 
					time=null");
	}
	
	function error_log($msg)
	{

		$log_msg = date("[Y-m-d H:i]", time()) . " " .$msg. "\n";
		//echo $log_msg;
				
		$filename= "log/error.log";
		$fp = @fopen($filename,"a");
		@fputs($fp, $log_msg);
		@fclose($fp); 

	}	
	
	function clear_error_logs()
	{

		$log_msg = date("[Y-m-d H:i]", time()) . " cleared LOGFILE !! \n";
				
		$filename= "log/error.log";
		$fp = @fopen($filename,"w");
		@fputs($fp, $log_msg);
		@fclose($fp); 

	}	

	
	
	
}


// ------------------------------------
// additonal functions fur general use
// ------------------------------------



function doLoginForm($error_msg = "")
{
	global $action;
	global $USER_NAME;
		
	//if (empty($USER_NAME)) $USER_NAME = "nobody";

	$tpl = new Template();
	$tpl->set_file("login", "tpl/login.html");

	$tpl->set_var
	(
		array(
			"ERROR" => $error_msg,
			"USER_NAME" => $USER_NAME,
			"ACTION" => $PHP_SELF
		)
	);

	$tpl->parse("out", "login");
	$tpl->p("out");	
	exit;
}

function doLogout()
{

	global $sid;
	global $logged_in;
	global $sess;
	
	$sess->logout($sid);
	unset($sid);	
	header ("Location: ../login.html");	
	echo "<br>";
	exit;
}


function doLogin()
{
	global $sess;
	global $USER_NAME;
	global $pwd;
	global $HTTP_SERVER_VARS;
	global $action;
		

	unset($action);
	
	return $sess->auth($USER_NAME,$pwd,$HTTP_SERVER_VARS["REMOTE_ADDR"]);
}


function showErrorPage($error_msg = "error")
{

	$tpl = new Template();
	$tpl->set_file("login", "tpl/error.html");

	$tpl->set_var
	(
		array(
			"ERROR_MSG" => $error_msg,
		)
	);

	$tpl->parse("out", "login");
	$tpl->p("out");	
	exit;
}
