/* 
-------------------------------------------------------------------------
./logicaland 0.1 - a participative global simulation
-------------------------------------------------------------------------
Copyright (c) 2002 ./logicaland (http://www.logicaland.net)
Michael Aschauer, Josef Deinhofer (io@logicland.net)
-------------------------------------------------------------------------
For information on usage and redistribution, and for a DISCLAIMER OF ALL
WARRANTIES, see the file, "LICENSE.txt," in this distribution.  
-------------------------------------------------------------------------
*/

package logica.gui;


import java.awt.*;
import java.awt.event.*;


public class Bar 
extends MapElement
{
	public Bar(String name, int id, float value)
	{                
		super();
		
		this.value = value;
		this.absoluteValue = value;		//sepp 020418;
		this.id = id;
		this.name = name;
		this.w = 5;
		
		changeHeight();		               
	}       			
	
	
	public void setValue(float v)
	{
		value = v;	
		changeHeight();
	}	
	
	public void changeHeight()
	{
		this.h = (int) value;	
		setSize(w,h);
	}		
	
	public void setWidth(int w)
	{
		this.w = w;
		setSize(w,h);
	}		
	
	public void paint(Graphics g)
	{
		if (isActive) 
		{
			g.setColor(Style.regionActive);			
			g.fillRect(0,0,w,h);			
			g.setColor(Style.regionActive);
			g.drawRect(0,0,w-1,h-1);
		}
		else if (hasFocus)
		{		
			g.setColor(Style.MiddleGrey);
			g.fillRect(0,0,w,h);			
			g.setColor(Style.regionActive);
			g.drawRect(0,0,w-1,h-1);			
		}
		else 
		{
			g.setColor(Style.MiddleGrey);
			g.fillRect(0,0,w,h);
		}
	}			
}

